/*******
* Implementation of M-Tree (Authors: Paolo Ciaccia, Marco Patella, Pavel Zezula)
* M-tree Web Page: http://www-db.deis.unibo.it/Mtree/
*************************************************
*
* Copyright (C) 2009 Ricardo J. Barrientos Rojel (ribarrie@dcc.uchile.cl)
*
* This program is free software; you can redistribute it and/or modify it
* under the terms of the GNU General Public License (http://www.gnu.org/licenses/gpl.txt)
* as published by the Free Software Foundation; either version 2 of the
* License, or (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
**********/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define INTERN 1
#define LEAF 2
#define ROOT 3
#define LEAF_ROOT 4
#define MAX_LINE 28
#define MAX_ENTRY 8
#define ERROR 10001

typedef int TipoDist;
typedef char TipoUser[MAX_LINE];

long int cuentaeditdist=0;

void copiavalor(TipoUser a, TipoUser b)
{
   strcpy(a, b);
}

TipoDist ed(char *p1, char *p2)
{
    int c[1000];
    register int pc,nc,j,i;
    register char cc;
    register int m = strlen(p1);
    cuentaeditdist++; /*variable global.. contador*/
    nc = m;
    p1--;
    for (j=0;j<=m;j++) c[j] = j;
    for (i=0;cc=p2[i];i++)
    {
       pc = i; nc = i+1;
       for (j=1;j<=m;j++)
       {
	  if (c[j] < nc)
	     nc = c[j];
	  pc += (cc != p1[j]);
	  if (pc <= nc)
	     nc = pc;
	  else
	     nc++;
	  pc = c[j]; c[j] = nc;
       }
    }
    return (TipoDist)nc;
}


TipoDist editdist(TipoUser p1, TipoUser p2)
{
    return ed((char *)p1, (char *)p2);
}

int leedato(char *dato,FILE *file)
{
   char buffer[1024];
   if (NULL != fgets(buffer, 1023, file))//the \n is stored in the end of the string
   {
      buffer[MAX_LINE-1] = '\0'; 
	  if (buffer[strlen(buffer)-1] == '\n')
		buffer[strlen(buffer)-1] = '\0';
      strcpy(dato, buffer);
      return 1;
   }
   else
      return ERROR;
}

//for case of vectors use "fabs(v)"
TipoDist v_abs(TipoDist v)
{
	return abs(v);
}



